/**************************\
*                          *
* Refer to the crypt.c     *
* program to see a demo    *
* on how to use these      *
* functions.  Feel free    *
* to use these functions   *
* in your programs.        *
*                          *
* Author: Endless Mind     *
* If you have any quesions *
* e-mail me at 103413,2767 *
*                          *
\**************************/





#include <stdlib.h>  // Needed for random number function: rand()

#define EVEN_BIT_MASK 0xAA // 10101010

#define ODD_BIT_MASK 0x55  // 01010101
 


// This function takes two parameters.  First, is the character to be 
// encrypted.  The second parameter should be 0.  The original character
// is spread throughout the two parameters.  This function returns nothing.
// This function mixes the original character with a random character.
// So, the letter 'A' would be encrypted differently every time, making 
// for hard decryption.  This method will keep MOST users from breaking
// into your data.  Example:

// Encrypt( &Original_Character,  &Second_Character);



void Encrypt(unsigned char *c,unsigned char *c2)

{
  
  int r = 0;  // Used for random number.
  
  int r_2 = 0;  // Second random number.
  
  r = rand() % 256;  // Chooses a random number between 0 and 256
  
  r_2 = rand() % 256; 
  
  // Places the odd bits from *c into *c2 and the even bits from the random
  // number into *c2
  
  *c2  =  ( ( *c & ODD_BIT_MASK  ) | ( r & EVEN_BIT_MASK ) );

  // Places the odd bits from the random number in *c, and keeps the original
  // even bits.
  
  *c   =  ( ( *c & EVEN_BIT_MASK ) | ( r_2 & ODD_BIT_MASK  ) );

}


// This function takes two characters that were encrypted by encrypt() and 
// takes the even bits from *c, and takes the odd bits from c2.  It stores 
// the decrypted character in *c.  Both *c and c2 must be unsigned characters.
// The first parameter must be a pointer to a character, or an address of one.
// Decrypt returns nothing. Example:

// Decrypt( &First_character, Second_character);



void Decrypt(unsigned char *c,unsigned char c2)

{

  *c  =  (  ( *c & EVEN_BIT_MASK ) | ( c2 & ODD_BIT_MASK )  );

}

